Loading...
Searching...
No Matches
BALL::SCWRLRotamerFile Class Reference

Reads Dunbrack/SCWRL rotamer library files. More...

`#include <BALL/FORMAT/SCWRLRotamerFile.h>`

Inheritance diagram for BALL::SCWRLRotamerFile:

## Public Member Functions

Constructors and Destructor
| SCWRLRotamerFile ()
| Default constructor.
| SCWRLRotamerFile (const String &name, File::OpenMode open_mode=std::ios::in)
| Detailed constructor.
virtual | ~SCWRLRotamerFile ()
| Destructor.
Assignment
const SCWRLRotamerFile & | operator= (const SCWRLRotamerFile &file)
| Assignment operator.
void | operator>> (RotamerLibrary &rotamer_library)
| input operator
void | readSCWRLBackboneDependentLibraryFile (RotamerLibrary &library)
void | readSCWRLBackboneIndependentLibraryFile (RotamerLibrary &library)
Public Member Functions inherited from BALL::LineBasedFile
| LineBasedFile ()
| Default constructor.
| LineBasedFile (const String &filename, File::OpenMode open_mode=std::ios::in, bool trim_whitespaces=false)
void | clear ()
bool | operator== (const LineBasedFile &f)
bool | operator!= (const LineBasedFile &f)
const LineBasedFile & | operator= (const LineBasedFile &file)
Position | getLineNumber () const
| Get the last line number in the file.
const String & | getLine () const
| Return the current line.
String & | getLine ()
| Return the current line.
bool | readLine ()
bool | skipLines (Size number=1)
bool | search (const String &text, bool return_to_start=false)
bool | search (const String &text, const String &stop, bool return_to_start=false)
bool | gotoLine (Position line_number)
void | rewind ()
void | test (const char *file, int line, bool condition, const String &msg) const
String | getField (Index pos=0, const String &quotes="", const String &delimiters=String::CHARACTER_CLASS__WHITESPACE) const
bool | startsWith (const String &text) const
| Test if the current line starts with text.
bool | has (const String &text) const
| Return true if the current line contains text.
Index | switchString (const std::vector< String > &data) const
bool | parseColumnFormat (const char *format, Position index, Size length, void *arg)
void | enableTrimWhitespaces (bool state)
| Set wheter leading and trailing whitespaces in lines shall be removed.
bool | trimWhiteSpacesEnabled () const
Public Member Functions inherited from BALL::File
| File ()
| File (const String &name, OpenMode open_mode=std::ios::in)
virtual | ~File ()
bool | isValid () const
bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
bool | reopen ()
bool | reopen (File::OpenMode open_mode)
void | close ()
const String & | getName () const
void | setName (const String &name)
const String & | getOriginalName () const
Size | getSize ()
File::OpenMode | getOpenMode () const
Type | getType (bool trace_link) const
bool | copyTo (const String &destination_name, Size buffer_size=4096)
bool | moveTo (const String &destination_name)
bool | remove ()
bool | renameTo (const String &new_path)
bool | truncate (Size size=0)
std::fstream & | getFileStream ()
TransformationManager & | getTransformationManager ()
const TransformationManager & | getTransformationManager () const
bool | operator== (const File &file) const
bool | operator!= (const File &file) const
bool | isOpen () const
bool | isClosed () const
bool | isAccessible () const
bool | isCanonized () const
bool | isReadable () const
bool | isWritable () const
bool | isExecutable () const

## Additional Inherited Members

Public Types inherited from BALL::File
typedef std::ios::openmode | OpenMode
enum | Transformation { TRANSFORMATION__EXEC = 1 , TRANSFORMATION__FILTER = 2 , TRANSFORMATION__URL = 3 }
enum | Type { TYPE__UNKNOWN = 0 , TYPE__DIRECTORY = 1 , TYPE__CHAR_SPECIAL_FILE = 2 , TYPE__BLOCK_SPECIAL_FILE = 3 , TYPE__REGULAR_FILE = 4 , TYPE__SYMBOLIC_LINK = 5 , TYPE__SOCKET = 6 , TYPE__FIFO_SPECIAL_FILE = 7 }
static Size | getSize (String name)
static Type | getType (String name, bool trace_link)
static bool | copy (String source_name, String destination_name, Size buffer_size=4096)
static bool | move (const String &source_name, const String &destination_name)
static bool | remove (String name)
static bool | rename (String old_path, String new_path)
static bool | truncate (String path, Size size=0)
static bool | createTemporaryFilename (String &temporary, const String &suffix=".TMP")
static void | enableTransformation (Transformation transformation)
static void | disableTransformation (Transformation transformation)
static bool | isTransformationEnabled (Transformation transformation)
static void | registerTransformation (const String &pattern, const String &exec)
static void | unregisterTransformation (const String &pattern)
static bool | isAccessible (String name)
static bool | isReadable (String name)
static bool | isWritable (String name)
static bool | isExecutable (String name)
Static Public Attributes inherited from BALL::File
static const OpenMode | MODE_IN
| Open for input (default).
static const OpenMode | MODE_OUT
| Open for output.
static const OpenMode | MODE_APP
| Append. Seek to end before each write operation.
static const OpenMode | MODE_BINARY
| Binary mode.
static const OpenMode | MODE_ATE
| Seek to end directly after opening.
static const OpenMode | MODE_TRUNC
| Truncate an existing file.
static const String | TRANSFORMATION_EXEC_PREFIX
| Prefix for filenames that are created through the execution of commands "exec:".
static const String | TRANSFORMATION_FILE_PREFIX
| Prefix for files (to mimick URL-like behavior) "file:".
static const String | TRANSFORMATION_FTP_PREFIX
| Prefix for FTP-transfers "ftp://".
static const String | TRANSFORMATION_HTTP_PREFIX
| Prefix for HTTP-transfer "http://".
String | line_
| buffer for the line in use
Position | line_number_
| line number in the file
bool | trim_whitespaces_
vector< char > | col_buffer_
| buffer for column parsing
String | name_
String | original_name_
OpenMode | open_mode_
bool | is_open_
bool | is_temporary_
static HashSet< String > | created_temp_filenames_
static TransformationManager | transformation_manager_
static Size | transformation_methods_

## Detailed Description

Reads Dunbrack/SCWRL rotamer library files.

This class is able to read the rotamer library files from Dunbrack including the one used in SCWRL3.0 . It decides if the file contains backbone dependent or backbone independent rotamers. Currently only files with the same format as bbdep02.May.lib or bbind02.May.lib are supported.

Definition at line 22 of file SCWRLRotamerFile.h.

## Constructor & Destructor Documentation

## SCWRLRotamerFile() [1/2]

BALL::SCWRLRotamerFile::SCWRLRotamerFile | ( |  | ) |

Default constructor.

## SCWRLRotamerFile() [2/2]

BALL::SCWRLRotamerFile::SCWRLRotamerFile | ( | const String & | name,
|  | File::OpenMode | open_mode = std::ios::in )

Detailed constructor.

## ~SCWRLRotamerFile()

virtual BALL::SCWRLRotamerFile::~SCWRLRotamerFile | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## operator=()

const SCWRLRotamerFile & BALL::SCWRLRotamerFile::operator= | ( | const SCWRLRotamerFile & | file | ) |

Assignment operator.

## operator>>()

void BALL::SCWRLRotamerFile::operator>> | ( | RotamerLibrary & | rotamer_library | ) |

input operator

## readSCWRLBackboneDependentLibraryFile()

void BALL::SCWRLRotamerFile::readSCWRLBackboneDependentLibraryFile | ( | RotamerLibrary & | library | ) |

Backbone depend read md method

Exceptions

  Exception::ParseError | if a syntax error encouncountered

## readSCWRLBackboneIndependentLibraryFile()

void BALL::SCWRLRotamerFile::readSCWRLBackboneIndependentLibraryFile | ( | RotamerLibrary & | library | ) |

Backbone independ readead method

Exceptions

  Exception::ParseError | if a syntax error encouncountered